diff --git a/external/fmt/test/format-test.cc b/external/fmt/test/format-test.cc
index 2a25566c..a8592ef0 100644
--- a/external/fmt/test/format-test.cc
+++ b/external/fmt/test/format-test.cc
@@ -1553,143 +1545,123 @@ TEST(FormatterTest, FormatExamples) {
         fclose(f);
       },
       error_code, "Cannot open file 'nonexistent'");
-}
 
-TEST(FormatterTest, Examples) {
   EXPECT_EQ("First, thou shalt count to three",
-            format("First, thou shalt count to {0}", "three"));
-  EXPECT_EQ("Bring me a shrubbery", format("Bring me a {}", "shrubbery"));
-  EXPECT_EQ("From 1 to 3", format("From {} to {}", 1, 3));
+            fmt::format("First, thou shalt count to {0}", "three"));
+  EXPECT_EQ("Bring me a shrubbery", fmt::format("Bring me a {}", "shrubbery"));
+  EXPECT_EQ("From 1 to 3", fmt::format("From {} to {}", 1, 3));
 
-  char buffer[BUFFER_SIZE];
+  char buffer[buffer_size];
   safe_sprintf(buffer, "%03.2f", -1.2);
-  EXPECT_EQ(buffer, format("{:03.2f}", -1.2));
+  EXPECT_EQ(buffer, fmt::format("{:03.2f}", -1.2));
 
-  EXPECT_EQ("a, b, c", format("{0}, {1}, {2}", 'a', 'b', 'c'));
-  EXPECT_EQ("a, b, c", format("{}, {}, {}", 'a', 'b', 'c'));
-  EXPECT_EQ("c, b, a", format("{2}, {1}, {0}", 'a', 'b', 'c'));
-  EXPECT_EQ("abracadabra", format("{0}{1}{0}", "abra", "cad"));
+  EXPECT_EQ("a, b, c", fmt::format("{0}, {1}, {2}", 'a', 'b', 'c'));
+  EXPECT_EQ("a, b, c", fmt::format("{}, {}, {}", 'a', 'b', 'c'));
+  EXPECT_EQ("c, b, a", fmt::format("{2}, {1}, {0}", 'a', 'b', 'c'));
+  EXPECT_EQ("abracadabra", fmt::format("{0}{1}{0}", "abra", "cad"));
 
-  EXPECT_EQ("left aligned                  ", format("{:<30}", "left aligned"));
+  EXPECT_EQ("left aligned                  ",
+            fmt::format("{:<30}", "left aligned"));
   EXPECT_EQ("                 right aligned",
-            format("{:>30}", "right aligned"));
-  EXPECT_EQ("           centered           ", format("{:^30}", "centered"));
-  EXPECT_EQ("***********centered***********", format("{:*^30}", "centered"));
+            fmt::format("{:>30}", "right aligned"));
+  EXPECT_EQ("           centered           ",
+            fmt::format("{:^30}", "centered"));
+  EXPECT_EQ("***********centered***********",
+            fmt::format("{:*^30}", "centered"));
 
-  EXPECT_EQ("+3.140000; -3.140000", format("{:+f}; {:+f}", 3.14, -3.14));
-  EXPECT_EQ(" 3.140000; -3.140000", format("{: f}; {: f}", 3.14, -3.14));
-  EXPECT_EQ("3.140000; -3.140000", format("{:-f}; {:-f}", 3.14, -3.14));
+  EXPECT_EQ("+3.140000; -3.140000", fmt::format("{:+f}; {:+f}", 3.14, -3.14));
+  EXPECT_EQ(" 3.140000; -3.140000", fmt::format("{: f}; {: f}", 3.14, -3.14));
+  EXPECT_EQ("3.140000; -3.140000", fmt::format("{:-f}; {:-f}", 3.14, -3.14));
 
   EXPECT_EQ("int: 42;  hex: 2a;  oct: 52",
-            format("int: {0:d};  hex: {0:x};  oct: {0:o}", 42));
+            fmt::format("int: {0:d};  hex: {0:x};  oct: {0:o}", 42));
   EXPECT_EQ("int: 42;  hex: 0x2a;  oct: 052",
-            format("int: {0:d};  hex: {0:#x};  oct: {0:#o}", 42));
+            fmt::format("int: {0:d};  hex: {0:#x};  oct: {0:#o}", 42));
 
-  EXPECT_EQ("The answer is 42", format("The answer is {}", 42));
-  EXPECT_THROW_MSG(format("The answer is {:d}", "forty-two"), format_error,
-                   "invalid type specifier");
-
-  EXPECT_EQ(L"Cyrillic letter \x42e", format(L"Cyrillic letter {}", L'\x42e'));
+  EXPECT_EQ("The answer is 42", fmt::format("The answer is {}", 42));
+  EXPECT_THROW_MSG(
+      (void)fmt::format(runtime("The answer is {:d}"), "forty-two"),
+      format_error, "invalid type specifier");
 
   EXPECT_WRITE(
       stdout, fmt::print("{}", std::numeric_limits<double>::infinity()), "inf");
 }
 
-TEST(FormatIntTest, Data) {
-  fmt::format_int format_int(42);
-  EXPECT_EQ("42", std::string(format_int.data(), format_int.size()));
-}
-
-TEST(FormatIntTest, FormatInt) {
-  EXPECT_EQ("42", fmt::format_int(42).str());
-  EXPECT_EQ(2u, fmt::format_int(42).size());
-  EXPECT_EQ("-42", fmt::format_int(-42).str());
-  EXPECT_EQ(3u, fmt::format_int(-42).size());
-  EXPECT_EQ("42", fmt::format_int(42ul).str());
-  EXPECT_EQ("-42", fmt::format_int(-42l).str());
-  EXPECT_EQ("42", fmt::format_int(42ull).str());
-  EXPECT_EQ("-42", fmt::format_int(-42ll).str());
-  std::ostringstream os;
-  os << max_value<int64_t>();
-  EXPECT_EQ(os.str(), fmt::format_int(max_value<int64_t>()).str());
-}
-
-TEST(FormatTest, Print) {
-#if FMT_USE_FCNTL
+TEST(format_test, print) {
   EXPECT_WRITE(stdout, fmt::print("Don't {}!", "panic"), "Don't panic!");
   EXPECT_WRITE(stderr, fmt::print(stderr, "Don't {}!", "panic"),
                "Don't panic!");
-#endif
-  // Check that the wide print overload compiles.
-  if (fmt::detail::const_check(false)) fmt::print(L"test");
 }
 
-TEST(FormatTest, Variadic) {
-  EXPECT_EQ("abc1", format("{}c{}", "ab", 1));
-  EXPECT_EQ(L"abc1", format(L"{}c{}", L"ab", 1));
+TEST(format_test, variadic) {
+  EXPECT_EQ("abc1", fmt::format("{}c{}", "ab", 1));
 }
 
-TEST(FormatTest, Dynamic) {
-  typedef fmt::format_context ctx;
-  std::vector<fmt::basic_format_arg<ctx>> args;
+TEST(format_test, dynamic) {
+  using ctx = fmt::format_context;
+  auto args = std::vector<fmt::basic_format_arg<ctx>>();
   args.emplace_back(fmt::detail::make_arg<ctx>(42));
   args.emplace_back(fmt::detail::make_arg<ctx>("abc1"));
   args.emplace_back(fmt::detail::make_arg<ctx>(1.5f));
 
   std::string result = fmt::vformat(
       "{} and {} and {}",
-      fmt::basic_format_args<ctx>(args.data(), static_cast<int>(args.size())));
+      fmt::format_args(args.data(), static_cast<int>(args.size())));
 
   EXPECT_EQ("42 and abc1 and 1.5", result);
 }
 
-TEST(FormatTest, Bytes) {
+TEST(format_test, bytes) {
   auto s = fmt::format("{:10}", fmt::bytes("ёжик"));
   EXPECT_EQ("ёжик  ", s);
   EXPECT_EQ(10, s.size());
 }
 
-TEST(FormatTest, JoinArg) {
+TEST(format_test, group_digits_view) {
+  EXPECT_EQ(fmt::format("{}", fmt::group_digits(10000000)), "10,000,000");
+  EXPECT_EQ(fmt::format("{:8}", fmt::group_digits(1000)), "   1,000");
+}
+
+enum test_enum { foo, bar };
+
+TEST(format_test, join) {
   using fmt::join;
   int v1[3] = {1, 2, 3};
-  std::vector<float> v2;
+  auto v2 = std::vector<float>();
   v2.push_back(1.2f);
   v2.push_back(3.4f);
   void* v3[2] = {&v1[0], &v1[1]};
 
-  EXPECT_EQ("(1, 2, 3)", format("({})", join(v1, v1 + 3, ", ")));
-  EXPECT_EQ("(1)", format("({})", join(v1, v1 + 1, ", ")));
-  EXPECT_EQ("()", format("({})", join(v1, v1, ", ")));
-  EXPECT_EQ("(001, 002, 003)", format("({:03})", join(v1, v1 + 3, ", ")));
+  EXPECT_EQ("(1, 2, 3)", fmt::format("({})", join(v1, v1 + 3, ", ")));
+  EXPECT_EQ("(1)", fmt::format("({})", join(v1, v1 + 1, ", ")));
+  EXPECT_EQ("()", fmt::format("({})", join(v1, v1, ", ")));
+  EXPECT_EQ("(001, 002, 003)", fmt::format("({:03})", join(v1, v1 + 3, ", ")));
   EXPECT_EQ("(+01.20, +03.40)",
-            format("({:+06.2f})", join(v2.begin(), v2.end(), ", ")));
+            fmt::format("({:+06.2f})", join(v2.begin(), v2.end(), ", ")));
 
-  EXPECT_EQ(L"(1, 2, 3)", format(L"({})", join(v1, v1 + 3, L", ")));
-  EXPECT_EQ("1, 2, 3", format("{0:{1}}", join(v1, v1 + 3, ", "), 1));
+  EXPECT_EQ("1, 2, 3", fmt::format("{0:{1}}", join(v1, v1 + 3, ", "), 1));
 
-  EXPECT_EQ(format("{}, {}", v3[0], v3[1]),
-            format("{}", join(v3, v3 + 2, ", ")));
+  EXPECT_EQ(fmt::format("{}, {}", v3[0], v3[1]),
+            fmt::format("{}", join(v3, v3 + 2, ", ")));
 
-#if !FMT_GCC_VERSION || FMT_GCC_VERSION >= 405
-  EXPECT_EQ("(1, 2, 3)", format("({})", join(v1, ", ")));
-  EXPECT_EQ("(+01.20, +03.40)", format("({:+06.2f})", join(v2, ", ")));
-#endif
-}
+  EXPECT_EQ("(1, 2, 3)", fmt::format("({})", join(v1, ", ")));
+  EXPECT_EQ("(+01.20, +03.40)", fmt::format("({:+06.2f})", join(v2, ", ")));
 
-template <typename T> std::string str(const T& value) {
-  return fmt::format("{}", value);
+  auto v4 = std::vector<test_enum>{foo, bar, foo};
+  EXPECT_EQ("0 1 0", fmt::format("{}", join(v4, " ")));
 }
 
-TEST(StrTest, Convert) {
-  EXPECT_EQ("42", str(42));
-  std::string s = str(Date(2012, 12, 9));
-  EXPECT_EQ("2012-12-9", s);
+#ifdef __cpp_lib_byte
+TEST(format_test, join_bytes) {
+  auto v = std::vector<std::byte>{std::byte(1), std::byte(2), std::byte(3)};
+  EXPECT_EQ("1, 2, 3", fmt::format("{}", fmt::join(v, ", ")));
 }
+#endif
 
 std::string vformat_message(int id, const char* format, fmt::format_args args) {
-  fmt::memory_buffer buffer;
-  format_to(buffer, "[{}] ", id);
-  vformat_to(buffer, format, args);
+  auto buffer = fmt::memory_buffer();
+  format_to(fmt::appender(buffer), "[{}] ", id);
+  vformat_to(fmt::appender(buffer), format, args);
   return to_string(buffer);
 }
 
@@ -1699,7 +1671,7 @@ std::string format_message(int id, const char* format, const Args&... args) {
   return vformat_message(id, format, va);
 }
 
-TEST(FormatTest, FormatMessageExample) {
+TEST(format_test, format_message_example) {
   EXPECT_EQ("[42] something happened",
             format_message(42, "{} happened", "something"));
 }
@@ -1711,7 +1683,7 @@ void print_error(const char* file, int line, const char* format,
   fmt::print(format, args...);
 }
 
-TEST(FormatTest, UnpackedArgs) {
+TEST(format_test, unpacked_args) {
   EXPECT_EQ("0123456789abcdefg",
             fmt::format("{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}{}", 0, 1, 2, 3, 4, 5,
                         6, 7, 8, 9, 'a', 'b', 'c', 'd', 'e', 'f', 'g'));
@@ -1722,11 +1694,29 @@ fmt::string_view to_string_view(string_like) { return "foo"; }
 
 constexpr char with_null[3] = {'{', '}', '\0'};
 constexpr char no_null[2] = {'{', '}'};
+static FMT_CONSTEXPR_DECL const char static_with_null[3] = {'{', '}', '\0'};
+static FMT_CONSTEXPR_DECL const char static_no_null[2] = {'{', '}'};
 
-TEST(FormatTest, CompileTimeString) {
+TEST(format_test, compile_time_string) {
+  EXPECT_EQ("foo", fmt::format(FMT_STRING("foo")));
   EXPECT_EQ("42", fmt::format(FMT_STRING("{}"), 42));
-  EXPECT_EQ(L"42", fmt::format(FMT_STRING(L"{}"), 42));
   EXPECT_EQ("foo", fmt::format(FMT_STRING("{}"), string_like()));
+
+#if FMT_USE_NONTYPE_TEMPLATE_PARAMETERS
+  using namespace fmt::literals;
+  EXPECT_EQ("foobar", fmt::format(FMT_STRING("{foo}{bar}"), "bar"_a = "bar",
+                                  "foo"_a = "foo"));
+  EXPECT_EQ("", fmt::format(FMT_STRING("")));
+  EXPECT_EQ("", fmt::format(FMT_STRING(""), "arg"_a = 42));
+#endif
+
+  (void)static_with_null;
+  (void)static_no_null;
+#ifndef _MSC_VER
+  EXPECT_EQ("42", fmt::format(FMT_STRING(static_with_null), 42));
+  EXPECT_EQ("42", fmt::format(FMT_STRING(static_no_null), 42));
+#endif
+
   (void)with_null;
   (void)no_null;
 #if __cplusplus >= 201703L
@@ -1735,13 +1725,12 @@ TEST(FormatTest, CompileTimeString) {
 #endif
 #if defined(FMT_USE_STRING_VIEW) && __cplusplus >= 201703L
   EXPECT_EQ("42", fmt::format(FMT_STRING(std::string_view("{}")), 42));
-  EXPECT_EQ(L"42", fmt::format(FMT_STRING(std::wstring_view(L"{}")), 42));
 #endif
 }
 
-TEST(FormatTest, CustomFormatCompileTimeString) {
+TEST(format_test, custom_format_compile_time_string) {
   EXPECT_EQ("42", fmt::format(FMT_STRING("{}"), Answer()));
-  Answer answer;
+  auto answer = Answer();
   EXPECT_EQ("42", fmt::format(FMT_STRING("{}"), answer));
   char buf[10] = {};
   fmt::format_to(buf, FMT_STRING("{}"), answer);
@@ -1756,153 +1745,98 @@ TEST(FormatTest, CustomFormatCompileTimeString) {
 
 using namespace fmt::literals;
 
-TEST(LiteralsTest, Format) {
-  auto udl_format = "{}c{}"_format("ab", 1);
-  EXPECT_EQ(format("{}c{}", "ab", 1), udl_format);
-  auto udl_format_w = L"{}c{}"_format(L"ab", 1);
-  EXPECT_EQ(format(L"{}c{}", L"ab", 1), udl_format_w);
-}
-
-TEST(LiteralsTest, NamedArg) {
-  auto udl_a = format("{first}{second}{first}{third}", "first"_a = "abra",
-                      "second"_a = "cad", "third"_a = 99);
-  EXPECT_EQ(format("{first}{second}{first}{third}", fmt::arg("first", "abra"),
-                   fmt::arg("second", "cad"), fmt::arg("third", 99)),
-            udl_a);
-  auto udl_a_w = format(L"{first}{second}{first}{third}", L"first"_a = L"abra",
-                        L"second"_a = L"cad", L"third"_a = 99);
-  EXPECT_EQ(
-      format(L"{first}{second}{first}{third}", fmt::arg(L"first", L"abra"),
-             fmt::arg(L"second", L"cad"), fmt::arg(L"third", 99)),
-      udl_a_w);
-}
+#  if FMT_GCC_VERSION
+#    define FMT_CHECK_DEPRECATED_UDL_FORMAT 1
+#  elif FMT_CLANG_VERSION && defined(__has_warning)
+#    if __has_warning("-Wdeprecated-declarations")
+#      define FMT_CHECK_DEPRECATED_UDL_FORMAT 1
+#    endif
+#  endif
+#  ifndef FMT_CHECK_DEPRECATED_UDL_FORMAT
+#    define FMT_CHECK_DEPRECATED_UDL_FORMAT 0
+#  endif
 
-TEST(FormatTest, UdlTemplate) {
-  EXPECT_EQ("foo", "foo"_format());
-  EXPECT_EQ("        42", "{0:10}"_format(42));
+#  if FMT_CHECK_DEPRECATED_UDL_FORMAT
+#    pragma GCC diagnostic push
+#    pragma GCC diagnostic ignored "-Wdeprecated-declarations"
+
+TEST(format_test, format_udl) {
+  EXPECT_EQ("{}c{}"_format("ab", 1), fmt::format("{}c{}", "ab", 1));
+  EXPECT_EQ("foo"_format(), "foo");
+  EXPECT_EQ("{0:10}"_format(42), "        42");
+  EXPECT_EQ("{}"_format(date(2015, 10, 21)), "2015-10-21");
 }
 
-TEST(FormatTest, UdlPassUserDefinedObjectAsLvalue) {
-  Date date(2015, 10, 21);
-  EXPECT_EQ("2015-10-21", "{}"_format(date));
+#    pragma GCC diagnostic pop
+#  endif
+
+TEST(format_test, named_arg_udl) {
+  auto udl_a = fmt::format("{first}{second}{first}{third}", "first"_a = "abra",
+                           "second"_a = "cad", "third"_a = 99);
+  EXPECT_EQ(
+      fmt::format("{first}{second}{first}{third}", fmt::arg("first", "abra"),
+                  fmt::arg("second", "cad"), fmt::arg("third", 99)),
+      udl_a);
 }
 #endif  // FMT_USE_USER_DEFINED_LITERALS
 
-enum TestEnum { A };
+TEST(format_test, enum) { EXPECT_EQ("0", fmt::format("{}", foo)); }
 
-TEST(FormatTest, Enum) { EXPECT_EQ("0", fmt::format("{}", A)); }
-
-TEST(FormatTest, FormatterNotSpecialized) {
-  static_assert(
-      !fmt::has_formatter<fmt::formatter<TestEnum>, fmt::format_context>::value,
-      "");
+TEST(format_test, formatter_not_specialized) {
+  static_assert(!fmt::has_formatter<fmt::formatter<test_enum>,
+                                    fmt::format_context>::value,
+                "");
 }
 
 #if FMT_HAS_FEATURE(cxx_strong_enums)
 enum big_enum : unsigned long long { big_enum_value = 5000000000ULL };
 
-TEST(FormatTest, StrongEnum) {
+TEST(format_test, strong_enum) {
   EXPECT_EQ("5000000000", fmt::format("{}", big_enum_value));
 }
 #endif
 
-using buffer_iterator = fmt::format_context::iterator;
-
-class mock_arg_formatter
-    : public fmt::detail::arg_formatter_base<buffer_iterator, char> {
- private:
-#if FMT_USE_INT128
-  MOCK_METHOD1(call, void(__int128_t value));
-#else
-  MOCK_METHOD1(call, void(long long value));
-#endif
-
- public:
-  using base = fmt::detail::arg_formatter_base<buffer_iterator, char>;
-
-  mock_arg_formatter(fmt::format_context& ctx, fmt::format_parse_context*,
-                     fmt::format_specs* s = nullptr, const char* = nullptr)
-      : base(ctx.out(), s, ctx.locale()) {
-    EXPECT_CALL(*this, call(42));
-  }
-
-  template <typename T>
-  typename std::enable_if<fmt::detail::is_integral<T>::value, iterator>::type
-  operator()(T value) {
-    call(value);
-    return base::operator()(value);
-  }
-
-  template <typename T>
-  typename std::enable_if<!fmt::detail::is_integral<T>::value, iterator>::type
-  operator()(T value) {
-    return base::operator()(value);
-  }
-
-  iterator operator()(fmt::basic_format_arg<fmt::format_context>::handle) {
-    return base::operator()(fmt::monostate());
-  }
-};
-
-static void custom_vformat(fmt::string_view format_str, fmt::format_args args) {
-  fmt::memory_buffer buffer;
-  fmt::detail::buffer<char>& base = buffer;
-  fmt::vformat_to<mock_arg_formatter>(std::back_inserter(base), format_str,
-                                      args);
-}
-
-template <typename... Args>
-void custom_format(const char* format_str, const Args&... args) {
-  auto va = fmt::make_format_args(args...);
-  return custom_vformat(format_str, va);
-}
-
-TEST(FormatTest, CustomArgFormatter) { custom_format("{}", 42); }
-
-TEST(FormatTest, NonNullTerminatedFormatString) {
-  EXPECT_EQ("42", format(string_view("{}foo", 2), 42));
+TEST(format_test, non_null_terminated_format_string) {
+  EXPECT_EQ("42", fmt::format(string_view("{}foo", 2), 42));
 }
 
 struct variant {
-  enum { INT, STRING } type;
-  explicit variant(int) : type(INT) {}
-  explicit variant(const char*) : type(STRING) {}
+  enum { int_type, string_type } type;
+  explicit variant(int) : type(int_type) {}
+  explicit variant(const char*) : type(string_type) {}
 };
 
 FMT_BEGIN_NAMESPACE
 template <> struct formatter<variant> : dynamic_formatter<> {
   auto format(variant value, format_context& ctx) -> decltype(ctx.out()) {
-    if (value.type == variant::INT) return dynamic_formatter<>::format(42, ctx);
+    if (value.type == variant::int_type)
+      return dynamic_formatter<>::format(42, ctx);
     return dynamic_formatter<>::format("foo", ctx);
   }
 };
 FMT_END_NAMESPACE
 
-TEST(FormatTest, DynamicFormatter) {
+TEST(format_test, dynamic_formatter) {
   auto num = variant(42);
   auto str = variant("foo");
-  EXPECT_EQ("42", format("{:d}", num));
-  EXPECT_EQ("foo", format("{:s}", str));
-  EXPECT_EQ(" 42 foo ", format("{:{}} {:{}}", num, 3, str, 4));
-  EXPECT_THROW_MSG(format("{0:{}}", num), format_error,
+  EXPECT_EQ("42", fmt::format("{:d}", num));
+  EXPECT_EQ("foo", fmt::format("{:s}", str));
+  EXPECT_EQ(" 42 foo ", fmt::format("{:{}} {:{}}", num, 3, str, 4));
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{0:{}}"), num), format_error,
                    "cannot switch from manual to automatic argument indexing");
-  EXPECT_THROW_MSG(format("{:{0}}", num), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:{0}}"), num), format_error,
                    "cannot switch from automatic to manual argument indexing");
-#if FMT_DEPRECATED_NUMERIC_ALIGN
-  EXPECT_THROW_MSG(format("{:=}", str), format_error,
-                   "format specifier requires numeric argument");
-#endif
-  EXPECT_THROW_MSG(format("{:+}", str), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:+}"), str), format_error,
                    "format specifier requires numeric argument");
-  EXPECT_THROW_MSG(format("{:-}", str), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:-}"), str), format_error,
                    "format specifier requires numeric argument");
-  EXPECT_THROW_MSG(format("{: }", str), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{: }"), str), format_error,
                    "format specifier requires numeric argument");
-  EXPECT_THROW_MSG(format("{:#}", str), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:#}"), str), format_error,
                    "format specifier requires numeric argument");
-  EXPECT_THROW_MSG(format("{:0}", str), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:0}"), str), format_error,
                    "format specifier requires numeric argument");
-  EXPECT_THROW_MSG(format("{:.2}", num), format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:.2}"), num), format_error,
                    "precision not allowed for this argument type");
 }
 
@@ -1926,15 +1860,23 @@ struct formatter<adl_test::fmt::detail::foo> : formatter<std::string> {
 };
 FMT_END_NAMESPACE
 
-TEST(FormatTest, ToString) {
-  EXPECT_EQ("42", fmt::to_string(42));
-  EXPECT_EQ("0x1234", fmt::to_string(reinterpret_cast<void*>(0x1234)));
-  EXPECT_EQ("foo", fmt::to_string(adl_test::fmt::detail::foo()));
-}
+struct convertible_to_int {
+  operator int() const { return value; }
 
-TEST(FormatTest, ToWString) { EXPECT_EQ(L"42", fmt::to_wstring(42)); }
+  int value = 42;
+};
 
-TEST(FormatTest, OutputIterators) {
+TEST(format_test, to_string) {
+  EXPECT_EQ(fmt::to_string(42), "42");
+  EXPECT_EQ(fmt::to_string(reinterpret_cast<void*>(0x1234)), "0x1234");
+  EXPECT_EQ(fmt::to_string(adl_test::fmt::detail::foo()), "foo");
+  EXPECT_EQ(fmt::to_string(convertible_to_int()), "42");
+
+  enum foo : unsigned char { zero };
+  EXPECT_EQ(fmt::to_string(zero), "0");
+}
+
+TEST(format_test, output_iterators) {
   std::list<char> out;
   fmt::format_to(std::back_inserter(out), "{}", 42);
   EXPECT_EQ("42", std::string(out.begin(), out.end()));
@@ -1943,21 +1885,60 @@ TEST(FormatTest, OutputIterators) {
   EXPECT_EQ("42", s.str());
 }
 
-TEST(FormatTest, FormattedSize) {
+TEST(format_test, formatted_size) {
   EXPECT_EQ(2u, fmt::formatted_size("{}", 42));
 }
 
-TEST(FormatTest, FormatToN) {
+TEST(format_test, format_to_no_args) {
+  std::string s;
+  fmt::format_to(std::back_inserter(s), "test");
+  EXPECT_EQ("test", s);
+}
+
+TEST(format_test, format_to) {
+  std::string s;
+  fmt::format_to(std::back_inserter(s), "part{0}", 1);
+  EXPECT_EQ("part1", s);
+  fmt::format_to(std::back_inserter(s), "part{0}", 2);
+  EXPECT_EQ("part1part2", s);
+}
+
+TEST(format_test, format_to_memory_buffer) {
+  auto buf = fmt::basic_memory_buffer<char, 100>();
+  fmt::format_to(fmt::appender(buf), "{}", "foo");
+  EXPECT_EQ("foo", to_string(buf));
+}
+
+TEST(format_test, format_to_vector) {
+  std::vector<char> v;
+  fmt::format_to(std::back_inserter(v), "{}", "foo");
+  EXPECT_EQ(string_view(v.data(), v.size()), "foo");
+}
+
+struct nongrowing_container {
+  using value_type = char;
+  void push_back(char) { throw std::runtime_error("can't take it any more"); }
+};
+
+TEST(format_test, format_to_propagates_exceptions) {
+  auto c = nongrowing_container();
+  EXPECT_THROW(fmt::format_to(std::back_inserter(c), "{}", 42),
+               std::runtime_error);
+}
+
+TEST(format_test, format_to_n) {
   char buffer[4];
   buffer[3] = 'x';
   auto result = fmt::format_to_n(buffer, 3, "{}", 12345);
   EXPECT_EQ(5u, result.size);
   EXPECT_EQ(buffer + 3, result.out);
   EXPECT_EQ("123x", fmt::string_view(buffer, 4));
+
   result = fmt::format_to_n(buffer, 3, "{:s}", "foobar");
   EXPECT_EQ(6u, result.size);
   EXPECT_EQ(buffer + 3, result.out);
   EXPECT_EQ("foox", fmt::string_view(buffer, 4));
+
   buffer[0] = 'x';
   buffer[1] = 'x';
   buffer[2] = 'x';
@@ -1965,30 +1946,20 @@ TEST(FormatTest, FormatToN) {
   EXPECT_EQ(1u, result.size);
   EXPECT_EQ(buffer + 1, result.out);
   EXPECT_EQ("Axxx", fmt::string_view(buffer, 4));
+
   result = fmt::format_to_n(buffer, 3, "{}{} ", 'B', 'C');
   EXPECT_EQ(3u, result.size);
   EXPECT_EQ(buffer + 3, result.out);
   EXPECT_EQ("BC x", fmt::string_view(buffer, 4));
-}
 
-TEST(FormatTest, WideFormatToN) {
-  wchar_t buffer[4];
-  buffer[3] = L'x';
-  auto result = fmt::format_to_n(buffer, 3, L"{}", 12345);
+  result = fmt::format_to_n(buffer, 4, "{}", "ABCDE");
   EXPECT_EQ(5u, result.size);
-  EXPECT_EQ(buffer + 3, result.out);
-  EXPECT_EQ(L"123x", fmt::wstring_view(buffer, 4));
-  buffer[0] = L'x';
-  buffer[1] = L'x';
-  buffer[2] = L'x';
-  result = fmt::format_to_n(buffer, 3, L"{}", L'A');
-  EXPECT_EQ(1u, result.size);
-  EXPECT_EQ(buffer + 1, result.out);
-  EXPECT_EQ(L"Axxx", fmt::wstring_view(buffer, 4));
-  result = fmt::format_to_n(buffer, 3, L"{}{} ", L'B', L'C');
-  EXPECT_EQ(3u, result.size);
-  EXPECT_EQ(buffer + 3, result.out);
-  EXPECT_EQ(L"BC x", fmt::wstring_view(buffer, 4));
+  EXPECT_EQ("ABCD", fmt::string_view(buffer, 4));
+
+  buffer[3] = 'x';
+  result = fmt::format_to_n(buffer, 3, "{}", std::string(1000, '*'));
+  EXPECT_EQ(1000u, result.size);
+  EXPECT_EQ("***x", fmt::string_view(buffer, 4));
 }
 
 struct test_output_iterator {
